#!/usr/bin/perl

# XXXXXXXXXXXXXXXXXXXXXXX

use Tk;
use Tk::ROText;
use Tk::BrowseEntry;
use File::Basename;
use DBI;
use Bio::Graphics;
use Bio::SeqFeature::Generic;
use POSIX;

require "connectDB.pl";

our $uname;
our $passwd;

# The following code creates a file to store the previous values
($name,$path,$suffix)=fileparse($0,"\.[^.]*");
$default_file = $ENV{'HOME'} . "/perl/".$name.".default";
open(DEFAULT_VALS,$default_file);

$mw = MainWindow->new(-title => $name);
# In the geometry function, the 900x500 is the size of the window 900 pixels horizontal, 500 pixels vertical
# +300+160 is the position on the screen where the window is to be pasted, 300 pixels from the left of the screen, 160 pixels from the top
$mw -> geometry('900x400+300+160');

# Create frame f1 in the main window 
$f1 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f2 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f3 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f4 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f5 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f6 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f7 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f8 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f9 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$f10 = $mw->Frame(-relief => 'ridge', -borderwidth => 2) ->pack(-fill => 'x');
$fbot = $mw->Frame() ->pack(-side=>'bottom',-fill => 'x');

# Create an go button
$go = $fbot->Button(-text => 'Go', -command => \&do_search)->pack(-side => 'left');
# Create an exit button
$ex = $fbot->Button(-text => 'Exit', -command => \&do_exit)->pack(-side => 'right');
# Create an edit button
$ed1 = $fbot->Button(-text => 'View Genes', -command => \&do_edit1)->pack();
$ed2 = $fbot->Button(-text => 'View Exons', -command => \&do_edit2)->pack();


# Creates Browse Entry pulldown box in frame f1
$filename = <DEFAULT_VALS>;
$filename =~ s/\s+$//; #remove trailing spaces
if ($filename ne "") { ($name,$path,$suffix) = fileparse($filename,"\.[^.]*"); }
$f1 -> Label(-text=>"Input File: ") -> pack(-side => 'left');  # creates a label in frame $f
$be1 = $f1->BrowseEntry(-variable => \$filename,-width=>50)->pack(-side => 'left');
$f1 -> Button(-text=>'Search',-command =>\&get_file1) -> pack(-side=>'left');

# Creates Browse Entry pulldown box in frame f2
$outfile = <DEFAULT_VALS>;
$outfile =~ s/\s+$//; #remove trailing spaces
$f2 -> Label(-text=>"Transcript File: ") -> pack(-side => 'left');  # creates a label in frame $f
$be2 = $f2->BrowseEntry(-variable => \$outfile,-width=>50)->pack(-side => 'left');
$f2 -> Button(-text=>'Search',-command =>\&get_file2) -> pack(-side=>'left');

$outfile2 = <DEFAULT_VALS>;
$outfile2 =~ s/\s+$//; #remove trailing spaces
$f3 -> Label(-text=>"Exon File: ") -> pack(-side => 'left');  # creates a label in frame $f
$be3 = $f3->BrowseEntry(-variable => \$outfile2,-width=>50)->pack(-side => 'left');
$f3 -> Button(-text=>'Search',-command =>\&get_file3) -> pack(-side=>'left');

$min_length = <DEFAULT_VALS>;
$min_length =~ s/\s+$//; #remove trailing spaces
$f4 -> Label(-text=>"Minimum gene footprint: ") -> pack(-side => 'left');  # creates a label in frame $f
$be4 = $f4->BrowseEntry(-variable => \$min_length,-width=>50)->pack(-side => 'left');

$junction_table = <DEFAULT_VALS>;
$junction_table =~ s/\s+$//; #remove trailing spaces
$f5 -> Label(-text=>"Junction table: ") -> pack(-side => 'left');  # creates a label in frame $f
$be5 = $f5->BrowseEntry(-variable => \$junction_table,-width=>50)->pack(-side => 'left');

# Initialize browse entry with some default values
$host = "localhost";
$dbase_name = "deep_seq";
$dbh = DBI -> connect("DBI:mysql:information_schema:$host",$uname,$passwd);
$query1 = "select table_name from tables where table_schema = \"$dbase_name\" order by table_name ASC";
$sqlquery1 = $dbh->prepare($query1) or die "Cannot prepare query \n";
$rv1 = $sqlquery1->execute or die "Cannot execute query \n";
@row = $sqlquery1->fetchrow_array();
while (defined $row[0])
{
	$be5->insert('end', $row[0]);
	@row = $sqlquery1->fetchrow_array();
}
$sqlquery1->finish;

$gene_prefix = <DEFAULT_VALS>;
$gene_prefix =~ s/\s+$//; #remove trailing spaces
$f6 -> Label(-text=>"Gene Name Prefix: ") -> pack(-side => 'left');  # creates a label in frame $f
$be6 = $f6->BrowseEntry(-variable => \$gene_prefix,-width=>50)->pack(-side => 'left');

$organism = <DEFAULT_VALS>;
$organism =~ s/\s+$//; #remove trailing spaces
$f7 -> Label(-text=>"Organism: ") -> pack(-side => 'left');  # creates a label in frame $f
$be7 = $f7->BrowseEntry(-variable => \$organism,-width=>50)->pack(-side => 'left');

# Initialize browse entry with some default values
$be7->insert('end', "Oryza sativa");
$be7->insert('end', "Arabidopsis thaliana");
$be7->insert('end', "Caenorhabditis elegans");
$be7->insert('end', "Drosophila melanogaster");
$be7->insert('end', "Yeast");
$be7->insert('end', "Test Genome");

close(DEFAULT_VALS);

MainLoop;

###############################################################################################
# This routine is called when the "Search" button is clicked

sub get_file1 {
$filename = $mw -> getOpenFile(-initialdir=>$path);
}

sub get_file2 {
$outfile = $mw -> getOpenFile(-initialdir=>$path);
}

sub get_file3 {
$outfile2 = $mw -> getOpenFile(-initialdir=>$path);
}

###############################################################################################

sub do_exit {
# Put commands here to be executed on exit
  exit;
}

sub save_defaults {
open(DEFAULT_VALUES,">$default_file");
$filename =~ s/\s+$//; #remove trailing spaces
$outfile =~ s/\s+$//; #remove trailing spaces
$outfile2 =~ s/\s+$//; #remove trailing spaces
$min_length =~ s/\s+$//; #remove trailing spaces
$junction_table =~ s/\s+$//; #remove trailing spaces
$gene_prefix =~ s/\s+$//; #remove trailing spaces
$organism =~ s/\s+$//; #remove trailing spaces
print DEFAULT_VALUES "$filename\n";
print DEFAULT_VALUES "$outfile\n";
print DEFAULT_VALUES "$outfile2\n";
print DEFAULT_VALUES "$min_length\n";
print DEFAULT_VALUES "$junction_table\n";
print DEFAULT_VALUES "$gene_prefix\n";
print DEFAULT_VALUES "$organism\n";
close(DEFAULT_VALUES);
}

###############################################################################################

sub do_edit1 {
$edit_cmd = "gedit " . $outfile;
system $edit_cmd;
}

sub do_edit2 {
$edit_cmd = "gedit " . $outfile2;
system $edit_cmd;
}

###############################################################################################

sub do_search
{

&save_defaults;
$debug = 1;

# all junctions greater than $max_junc_allowed will be ignored regardless of whether or not it can link 2 exons together
$max_junc_allowed = 50000;

$database = "deep_seq";
$host = "localhost";
$dbh = DBI -> connect("DBI:mysql:$database:$host",$uname,$passwd);

open(INFILE,$filename) || die "Cannot open input file $filename\n";
open(OUTFILE,">$outfile") || die "Cannot open output file $outfile\n";
#print OUTFILE "Chromosome\tStart Pos\tEnd Pos\tGene name\tRead Count\n";

open(OUTFILE2,">$outfile2") || die "Cannot open output file $outfile2\n";
#print OUTFILE2 "Chromosome\tStart Pos\tEnd Pos\tExon name\tRead Count\n";



$debug = 0;

$header_line = <INFILE>;
$exon_row = <INFILE>;

# load the exon file into memory
$i = 0;
while (defined $exon_row)
{
	$i++;
	$exons[$i] = $exon_row;
	$used[$i] = "F";
	$exon_row = <INFILE>;
}
$total_exons = $i;
print "Exons loaded\t$i\n";

$debug++;

$gene_count = 0;	# number of genes found
$exon_pos = 1;		# set to first exon
while ($exon_pos <= $total_exons)
{

	&find_gene($exon_pos);

	# Calculate the sum of the lengths of the exons of the gene
	$j = $first_exon;
	$i = 1;
	$gene_length = 0;
	while ($i <= $exon_count)
	{
		@row = split("\t",$gene_exons[$j]);
		$gene_length = $gene_length + ($row[2] - $row[1]) + 1;
		$j++;
		$i++;
	}


if ($gene_length >= $min_length)
{
	$gene_count++;
	$gene_name = $gene_prefix.substr("00000".$gene_count,-5);
	if (($gene_count%1000) == 0)
	{
		print "$gene_count\t$gene_chrom\t$gene_start\t$gene_end\t$gene_name\t$exon_count\t$gene_length\n";
	}

	# Print gene
	print OUTFILE "$gene_chrom\t$gene_start\t$gene_end\t$gene_name\t.\t+\t$gene_length\n";

	# Print exons of gene
	$j = $first_exon;
	$i = 1;
	while ($i <= $exon_count)
	{
		@row = split("\t",$gene_exons[$j]);
		print OUTFILE2 "$row[0]\t$row[1]\t$row[2]\t$gene_name\t.\t+\n";
		$j++;
		$i++;
	}
}

	# Increment $exon_pos
	$exon_pos++;
	while ($used[$exon_pos] eq "T")
	{$exon_pos++;}


} #endwhile ($exon_pos <= $max_exons)


close(INFILE);
close(OUTFILE);
close(OUTFILE2);

print "Finished\n";
}

################################################################################################

# This subroutine sets the variables $gene_count,$gene_chrom,$gene_start,$gene_end,$exon_count,$gene_length and
# stores all the exons of the gene into @gene_exons

sub find_gene
{
my ($exon_pos) = @_;

$first_exon = 100;	# gene_exons[$first_exon] is the first exon of the gene
$exon_index = 100;	# this variable gets incremented/decremented every time an exon is added to the gene
$exon_count = 1;	# this is the number of exons in the gene
@gene_exons = ();	# reset current gene

# Add first exon to gene
$used[$exon_pos] = "T";
$gene_exons[$exon_index] = $exons[$exon_pos];
@row = split("\t",$exons[$exon_pos]);
$chrom = $row[0];
$start_pos = $row[1];
$end_pos = $row[2];
$exon_len = $row[3];
$gene_chrom = $chrom;		# update gene chrom
$gene_start = $start_pos;	# update gene start
$gene_end = $end_pos;		# update gene end

# search backward for exons
$prev_exon = &get_prev_exons($exon_pos);	# This updates $intron_start,$intron_end
while ($prev_exon > 0)
{
	&add_exon_to_gene($prev_exon,"-",$intron_start,$intron_end); # $exon_index is decremented
	$exon_pos = $prev_exon;	# Note: $exon_pos is a local variable so this is just a temporary change.
	$prev_exon = &get_prev_exons($exon_pos);	# This updates $intron_start,$intron_end
}

# search forward for exons
($exon_pos) = @_;	# Reset $exon_pos to original value
$exon_index = 100;	# Reset $exon_index
$last_intron_end = 0;
$next_exon = &get_next_exons($exon_pos,$last_intron_end);	# This updates $intron_start,$intron_end
while ($next_exon > 0)
{
	&add_exon_to_gene($next_exon,"+",$intron_start,$intron_end); # $exon_index is incremented
	$exon_pos = $next_exon;	# Note: $exon_pos is a local variable so this is just a temporary change.
	$last_intron_end = $intron_end;
	$next_exon = &get_next_exons($exon_pos,$last_intron_end);	# This updates $intron_start,$intron_end
}

} # endsub

################################################################################################

# This subroutine adjusts the $exon_index,$gene_start,$gene_end,$gene_exons[$exon_index] and $used[$exon_pos]

sub add_exon_to_gene
{
my ($exon_pos,$direction,$int_start,$int_end) = @_;

	@row = split("\t",$exons[$exon_pos]);
	$chrom = $row[0];
	$start_pos = $row[1];
	$end_pos = $row[2];

	@row = split("\t",$gene_exons[$exon_index]);
	$gchrom = $row[0];
	$gstart_pos = $row[1];
	$gend_pos = $row[2];

	$used[$exon_pos] = "T";
	$exon_count++; 
	if ($direction eq "+")
	{ 
	$gene_exons[$exon_index] = "$gchrom\t$gstart_pos\t$int_start";	# set the end of the exon to the start of the intron
	$exon_index++;
	$gene_end = $end_pos;		# update gene end
	$gene_exons[$exon_index] = "$gchrom\t$int_end\t$end_pos";	# set the start of the next exon to the end of the intron
	}
	else # ($direction eq "-")
	{ 
	$gene_exons[$exon_index] = "$gchrom\t$int_end\t$gend_pos";	# set the start of the exon to the end of the intron
	$exon_index--;
	$first_exon--;
	$gene_start = $start_pos;		# update gene start
	$gene_exons[$exon_index] = "$gchrom\t$start_pos\t$int_start";	# set the end of the exon to the start of the intron
	}
}

################################################################################################

sub get_prev_exons
{

my ($exon_pos) = @_;
my ($chrom,$start_pos,$end_pos) = split("\t",$exons[$exon_pos]);

# find junctions that start in current exon and go back
$query = "SELECT junction_name,number,start_pos,end_pos,chromosome,left_side,right_side FROM $junction_table WHERE (chromosome = \"$chrom\") AND ((end_pos >= $start_pos) AND (end_pos <= $end_pos)) AND (start_pos <= $start_pos) order by number DESC";
	
$sqlquery = $dbh->prepare($query) or die "Cannot prepare query \n";
$rv = $sqlquery->execute or die "Cannot execute query \n";
@junc_row = $sqlquery->fetchrow_array();
$junction_name = $junc_row[0];
$junction_count = $junc_row[1];
$junction_start = $junc_row[2];
$junction_end = $junc_row[3];
$junction_len = $junction_end - $junction_start;
$junction_left = $junc_row[5];
$junction_right = $junc_row[6];
$intron_start = $junction_start + $junction_left;
$intron_end = ($junction_end - $junction_right);

my $exon_indx = 0;
if (defined $junction_name)
{ $exon_indx = get_prev_exon($exon_pos,$chrom,$junction_start); }

# keep going through the junctions until we find a junction that lands on a downstream exon
while (($exon_indx == 0) and (defined $junction_name))
{
	@junc_row = $sqlquery->fetchrow_array();
	$junction_name = $junc_row[0];
	$junction_count = $junc_row[1];
	$junction_start = $junc_row[2];
	$junction_end = $junc_row[3];
	$junction_len = $junction_end - $junction_start;
	$junction_left = $junc_row[5];
	$junction_right = $junc_row[6];
	$intron_start = $junction_start + $junction_left;
	$intron_end = ($junction_end - $junction_right);
	if (defined $junction_name)
	{ $exon_indx = get_prev_exon($exon_pos,$chrom,$junction_start); }
} #endwhile

return $exon_indx;

} # endsub

################################################################################################

sub get_next_exons
{

my ($exon_pos,$last_intron_start) = @_;
my ($chrom,$start_pos,$end_pos) = split("\t",$exons[$exon_pos]);

# This code was added to prevent negative exon lengths from overlapping junctions
if ($last_intron_start > 0)
{ $start_pos = $last_intron_start; }

# find junctions that start in current exon
$query = "SELECT junction_name,number,start_pos,end_pos,chromosome,left_side,right_side FROM $junction_table WHERE (chromosome = \"$chrom\") AND ((start_pos >= $start_pos) AND (start_pos <= $end_pos)) AND (end_pos >= $end_pos) order by number DESC";
	
$sqlquery = $dbh->prepare($query) or die "Cannot prepare query \n";
$rv = $sqlquery->execute or die "Cannot execute query \n";
@junc_row = $sqlquery->fetchrow_array();

# If a junction is not found, try again
if (!defined $junc_row[0])
{
$query = "SELECT junction_name,number,start_pos,end_pos,chromosome,left_side,right_side FROM $junction_table WHERE (chromosome = \"$chrom\") AND ((intron_start >= $start_pos) AND (intron_start <= $end_pos)) AND (end_pos >= $end_pos) order by number DESC";
$sqlquery = $dbh->prepare($query) or die "Cannot prepare query \n";
$rv = $sqlquery->execute or die "Cannot execute query \n";
@junc_row = $sqlquery->fetchrow_array();
}

$junction_name = $junc_row[0];
$junction_count = $junc_row[1];
$junction_start = $junc_row[2];
$junction_end = $junc_row[3];
$junction_len = $junction_end - $junction_start;
$junction_left = $junc_row[5];
$junction_right = $junc_row[6];
$intron_start = $junction_start + $junction_left;
$intron_end = ($junction_end - $junction_right);
my $exon_indx = 0;
if (defined $junction_name)
{ $exon_indx = get_next_exon($exon_pos,$chrom,$junction_end,$intron_end); }

# keep going through the junctions until we find a junction that lands on a downstream exon
while (($exon_indx == 0) and (defined $junction_name))
{
	@junc_row = $sqlquery->fetchrow_array();
	$junction_name = $junc_row[0];
	$junction_count = $junc_row[1];
	$junction_start = $junc_row[2];
	$junction_end = $junc_row[3];
	$junction_len = $junction_end - $junction_start;
	$junction_left = $junc_row[5];
	$junction_right = $junc_row[6];
	$intron_start = $junction_start + $junction_left;
	$intron_end = ($junction_end - $junction_right);
	$exon_indx = 0;
	if (defined $junction_name)
	{ $exon_indx = get_next_exon($exon_pos,$chrom,$junction_end,$intron_end); }
} #endwhile

return $exon_indx;

} # endsub

################################################################################################

sub get_prev_exon
{

my ($exon_index,$chrom,$junction_start) = @_;
my ($start_pos,$end_pos,$exon_len) = ();

$exon_index--;
@row = split("\t",$exons[$exon_index]);
$prev_chrom = $row[0];
$start_pos = $row[1];
$end_pos = $row[2];
# skip over exons in intronic regions
while (($start_pos >= $junction_start) && ($prev_chrom eq $chrom))
{
	$exon_index--;
	@row = split("\t",$exons[$exon_index]);
	$prev_chrom = $row[0];
	$start_pos = $row[1];
	$end_pos = $row[2];
} # endwhile

if ($end_pos < $junction_start)
{
	return 0;
}
else
{
	return $exon_index;
} # endif

} # endsub

################################################################################################

sub get_next_exon
{

my ($exon_index,$chrom,$junction_end,$intron_end) = @_;
my ($start_pos,$end_pos,$exon_len) = ();

$exon_index++;
@row = split("\t",$exons[$exon_index]);
$next_chrom = $row[0];
$start_pos = $row[1];
$end_pos = $row[2];
# skip over exons until we have an exon where the end of the exon is past the end of the intron
while (($end_pos <= $intron_end) && ($next_chrom eq $chrom))
{
	$exon_index++;
	@row = split("\t",$exons[$exon_index]);
	$next_chrom = $row[0];
	$start_pos = $row[1];
	$end_pos = $row[2];
} # endwhile

if ($start_pos > $junction_end)	# if the exon is past the end of the junction, then return 0
{
	return 0;
}
else				# if the end of the junction lies within the exon, return the exon
{
	return $exon_index;
} # endif

} # endsub


